/* Database.c generated by valac 0.46.6, the Vala compiler
 * generated from Database.vala, do not modify */

/*
* Copyright (c) 2017 Robert San <robertsanseries@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <libgda/libgda.h>
#include <float.h>
#include <math.h>

#define KARIM_CORE_TYPE_DATABASE (karim_core_database_get_type ())
#define KARIM_CORE_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KARIM_CORE_TYPE_DATABASE, KarimCoreDatabase))
#define KARIM_CORE_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KARIM_CORE_TYPE_DATABASE, KarimCoreDatabaseClass))
#define KARIM_CORE_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KARIM_CORE_TYPE_DATABASE))
#define KARIM_CORE_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KARIM_CORE_TYPE_DATABASE))
#define KARIM_CORE_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KARIM_CORE_TYPE_DATABASE, KarimCoreDatabaseClass))

typedef struct _KarimCoreDatabase KarimCoreDatabase;
typedef struct _KarimCoreDatabaseClass KarimCoreDatabaseClass;
typedef struct _KarimCoreDatabasePrivate KarimCoreDatabasePrivate;
enum  {
	KARIM_CORE_DATABASE_0_PROPERTY,
	KARIM_CORE_DATABASE_NUM_PROPERTIES
};
static GParamSpec* karim_core_database_properties[KARIM_CORE_DATABASE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KarimCoreDatabase {
	GObject parent_instance;
	KarimCoreDatabasePrivate * priv;
	gchar* provider;
	gchar* data_dir;
	gchar* dir_path;
	GFile* database_dir;
	gchar* hostname;
};

struct _KarimCoreDatabaseClass {
	GObjectClass parent_class;
};

struct _KarimCoreDatabasePrivate {
	GdaConnection* connection;
};

static gint KarimCoreDatabase_private_offset;
static gpointer karim_core_database_parent_class = NULL;

GType karim_core_database_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KarimCoreDatabase, g_object_unref)
KarimCoreDatabase* karim_core_database_new (void);
KarimCoreDatabase* karim_core_database_construct (GType object_type);
static void karim_core_database_check_dir (KarimCoreDatabase* self);
static void karim_core_database_create_database (KarimCoreDatabase* self);
static void karim_core_database_create_connection (KarimCoreDatabase* self);
static void karim_core_database_create_table_downloads (KarimCoreDatabase* self,
                                                 GError** error);
GdaConnection* karim_core_database_get_connection (KarimCoreDatabase* self);
static void karim_core_database_finalize (GObject * obj);

static inline gpointer
karim_core_database_get_instance_private (KarimCoreDatabase* self)
{
	return G_STRUCT_MEMBER_P (self, KarimCoreDatabase_private_offset);
}

/**
         * Constructor
         */
KarimCoreDatabase*
karim_core_database_construct (GType object_type)
{
	KarimCoreDatabase * self = NULL;
	GError* _inner_error0_ = NULL;
	self = (KarimCoreDatabase*) g_object_new (object_type, NULL);
	{
		gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp0_ = g_strdup ("SQLite");
		_g_free0 (self->provider);
		self->provider = _tmp0_;
		_tmp1_ = g_get_user_data_dir ();
		_tmp2_ = g_strdup (_tmp1_);
		_g_free0 (self->data_dir);
		self->data_dir = _tmp2_;
		_tmp3_ = self->data_dir;
		_tmp4_ = g_build_path (G_DIR_SEPARATOR_S, _tmp3_, "karim", NULL);
		_g_free0 (self->dir_path);
		self->dir_path = _tmp4_;
		_tmp5_ = self->dir_path;
		_tmp6_ = g_file_new_for_path (_tmp5_);
		_g_object_unref0 (self->database_dir);
		self->database_dir = _tmp6_;
		_tmp7_ = self->database_dir;
		_tmp8_ = g_file_get_path (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strdup_printf ("DB_DIR=%s;DB_NAME=%s", _tmp9_, "karim");
		_g_free0 (self->hostname);
		self->hostname = _tmp10_;
		_g_free0 (_tmp9_);
		karim_core_database_check_dir (self);
		karim_core_database_create_database (self);
		karim_core_database_create_connection (self);
		karim_core_database_create_table_downloads (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		g_critical ("Database.vala:49: %s", _tmp12_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	return self;
}

KarimCoreDatabase*
karim_core_database_new (void)
{
	return karim_core_database_construct (KARIM_CORE_TYPE_DATABASE);
}

/**
         * Get connection.
         * 
         * @return {@code Connection}
         */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GdaConnection*
karim_core_database_get_connection (KarimCoreDatabase* self)
{
	GdaConnection* _tmp0_;
	GdaConnection* _tmp1_;
	GdaConnection* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->connection;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

/**
         * Check directory.
         * 
         * @return void
         */
static void
karim_core_database_check_dir (KarimCoreDatabase* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GFile* _tmp0_;
		_tmp0_ = self->database_dir;
		g_file_make_directory_with_parents (_tmp0_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = err;
		if (g_error_matches (_tmp1_, G_IO_ERROR, G_IO_ERROR_EXISTS) == FALSE) {
			GError* _tmp2_;
			const gchar* _tmp3_;
			_tmp2_ = err;
			_tmp3_ = _tmp2_->message;
			g_error ("Database.vala:72: %s", _tmp3_);
		}
		_g_error_free0 (err);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

/**
         * Create database if it does not exist.
         * 
         * @return void
         */
static void
karim_core_database_create_database (KarimCoreDatabase* self)
{
	GFile* db_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean new_db = FALSE;
	GFile* _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->database_dir;
	_tmp1_ = g_file_get_child (_tmp0_, "karim.db");
	db_file = _tmp1_;
	_tmp2_ = db_file;
	new_db = !g_file_query_exists (_tmp2_, NULL);
	if (new_db) {
		{
			GFile* _tmp3_;
			GFileOutputStream* _tmp4_;
			GFileOutputStream* _tmp5_;
			_tmp3_ = db_file;
			_tmp4_ = g_file_create (_tmp3_, G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
			_tmp5_ = _tmp4_;
			_g_object_unref0 (_tmp5_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp6_ = e;
			_tmp7_ = _tmp6_->message;
			g_critical ("Database.vala:90: %s", _tmp7_);
			_g_error_free0 (e);
		}
		__finally2:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (db_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_g_object_unref0 (db_file);
}

/**
         * Initiate connection with data bank
         * 
         * @return void
         */
static void
karim_core_database_create_connection (KarimCoreDatabase* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GdaConnection* _tmp0_ = NULL;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		GdaConnection* _tmp3_;
		GdaConnection* _tmp4_;
		_tmp1_ = self->provider;
		_tmp2_ = self->hostname;
		_tmp3_ = gda_connection_open_from_string (_tmp1_, _tmp2_, NULL, GDA_CONNECTION_OPTIONS_NONE, &_inner_error0_);
		_tmp0_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch3_g_error;
		}
		_tmp4_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->connection);
		self->priv->connection = _tmp4_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = e->message;
		g_error ("Database.vala:109: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

/**
         * Create table downloads if it does not exist
         * 
         * @return void
         */
static void
karim_core_database_create_table_downloads (KarimCoreDatabase* self,
                                            GError** error)
{
	GdaConnection* _tmp0_;
	GError* e = NULL;
	GdaServerOperation* operation = NULL;
	GdaConnection* _tmp1_;
	GError* _tmp2_;
	GdaServerOperation* _tmp3_;
	GError* _tmp4_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->connection;
	_vala_return_if_fail (gda_connection_is_opened (_tmp0_), "this.connection.is_opened()");
	e = NULL;
	_tmp1_ = self->priv->connection;
	_tmp2_ = e;
	_tmp3_ = gda_server_operation_prepare_create_table (_tmp1_, "downloads", _tmp2_, "id", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_PKEY_AUTOINC_FLAG, "name", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "url", G_TYPE_STRING, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "progress", G_TYPE_DOUBLE, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, "percentage", G_TYPE_INT, GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG, NULL);
	operation = _tmp3_;
	_tmp4_ = e;
	if (_tmp4_ != NULL) {
		GError* _tmp5_;
		const gchar* _tmp6_;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_critical ("Database.vala:130: %s", _tmp6_);
	} else {
		{
			GdaServerOperation* _tmp7_;
			_tmp7_ = operation;
			gda_server_operation_perform_create_table (_tmp7_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch4_g_error;
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp8_ = e;
			_tmp9_ = _tmp8_->message;
			g_message ("Database.vala:135: %s", _tmp9_);
			_g_error_free0 (e);
		}
		__finally4:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (operation);
			_g_error_free0 (e);
			return;
		}
	}
	_g_object_unref0 (operation);
	_g_error_free0 (e);
}

static void
karim_core_database_class_init (KarimCoreDatabaseClass * klass,
                                gpointer klass_data)
{
	karim_core_database_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &KarimCoreDatabase_private_offset);
	G_OBJECT_CLASS (klass)->finalize = karim_core_database_finalize;
}

static void
karim_core_database_instance_init (KarimCoreDatabase * self,
                                   gpointer klass)
{
	self->priv = karim_core_database_get_instance_private (self);
}

static void
karim_core_database_finalize (GObject * obj)
{
	KarimCoreDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KARIM_CORE_TYPE_DATABASE, KarimCoreDatabase);
	_g_object_unref0 (self->priv->connection);
	_g_free0 (self->provider);
	_g_free0 (self->data_dir);
	_g_free0 (self->dir_path);
	_g_object_unref0 (self->database_dir);
	_g_free0 (self->hostname);
	G_OBJECT_CLASS (karim_core_database_parent_class)->finalize (obj);
}

GType
karim_core_database_get_type (void)
{
	static volatile gsize karim_core_database_type_id__volatile = 0;
	if (g_once_init_enter (&karim_core_database_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (KarimCoreDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) karim_core_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KarimCoreDatabase), 0, (GInstanceInitFunc) karim_core_database_instance_init, NULL };
		GType karim_core_database_type_id;
		karim_core_database_type_id = g_type_register_static (G_TYPE_OBJECT, "KarimCoreDatabase", &g_define_type_info, 0);
		KarimCoreDatabase_private_offset = g_type_add_instance_private (karim_core_database_type_id, sizeof (KarimCoreDatabasePrivate));
		g_once_init_leave (&karim_core_database_type_id__volatile, karim_core_database_type_id);
	}
	return karim_core_database_type_id__volatile;
}

