/* FileUtil.c generated by valac 0.46.6, the Vala compiler
 * generated from FileUtil.vala, do not modify */

/*
* Copyright (c) 2017 Robert San <robertsanseries@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>

#define KARIM_UTILS_TYPE_FILE_UTIL (karim_utils_file_util_get_type ())
#define KARIM_UTILS_FILE_UTIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KARIM_UTILS_TYPE_FILE_UTIL, KarimUtilsFileUtil))
#define KARIM_UTILS_FILE_UTIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KARIM_UTILS_TYPE_FILE_UTIL, KarimUtilsFileUtilClass))
#define KARIM_UTILS_IS_FILE_UTIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KARIM_UTILS_TYPE_FILE_UTIL))
#define KARIM_UTILS_IS_FILE_UTIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KARIM_UTILS_TYPE_FILE_UTIL))
#define KARIM_UTILS_FILE_UTIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KARIM_UTILS_TYPE_FILE_UTIL, KarimUtilsFileUtilClass))

typedef struct _KarimUtilsFileUtil KarimUtilsFileUtil;
typedef struct _KarimUtilsFileUtilClass KarimUtilsFileUtilClass;
typedef struct _KarimUtilsFileUtilPrivate KarimUtilsFileUtilPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _KarimUtilsParamSpecFileUtil KarimUtilsParamSpecFileUtil;

struct _KarimUtilsFileUtil {
	GTypeInstance parent_instance;
	volatile int ref_count;
	KarimUtilsFileUtilPrivate * priv;
};

struct _KarimUtilsFileUtilClass {
	GTypeClass parent_class;
	void (*finalize) (KarimUtilsFileUtil *self);
};

struct _KarimUtilsParamSpecFileUtil {
	GParamSpec parent_instance;
};

static gpointer karim_utils_file_util_parent_class = NULL;

gpointer karim_utils_file_util_ref (gpointer instance);
void karim_utils_file_util_unref (gpointer instance);
GParamSpec* karim_utils_param_spec_file_util (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
void karim_utils_value_set_file_util (GValue* value,
                                      gpointer v_object);
void karim_utils_value_take_file_util (GValue* value,
                                       gpointer v_object);
gpointer karim_utils_value_get_file_util (const GValue* value);
GType karim_utils_file_util_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KarimUtilsFileUtil, karim_utils_file_util_unref)
void karim_utils_file_util_open_folder_file_app (gchar** uris,
                                                 gint uris_length1);
#define KARIM_UTILS_STRING_UTIL_SPACE " "
void karim_utils_file_util_create_file (const gchar* dir,
                                        const gchar* name_file,
                                        gchar** words,
                                        gint words_length1);
#define KARIM_UTILS_STRING_UTIL_EMPTY ""
void karim_utils_file_util_delete_file (const gchar* dir,
                                        const gchar* name_file);
KarimUtilsFileUtil* karim_utils_file_util_new (void);
KarimUtilsFileUtil* karim_utils_file_util_construct (GType object_type);
static void karim_utils_file_util_finalize (KarimUtilsFileUtil * obj);

/**
     * Open folder in app files.
     *
     * @since 1.0
     * @author Robert San - @robertsanseries
     *         Based on code - Jeremy Wootten <jeremy@elementaryos.org>
     *         	https://github.com/elementary/files/blob/ac10bd5a7298a89bb1a53eefd24a2991539f91a5/pantheon-files-daemon/FileManager1.vala
     *
     * Exemple:
     * > FileUtil.open_folder_files(uris)
     * 
     * @param {@code string} - uris
     */
void
karim_utils_file_util_open_folder_file_app (gchar** uris,
                                            gint uris_length1)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = g_strdup ("pantheon-files -t");
	cmd = _tmp0_;
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = uris;
		s_collection_length1 = uris_length1;
		for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
			gchar* _tmp1_;
			gchar* s = NULL;
			_tmp1_ = g_strdup (s_collection[s_it]);
			s = _tmp1_;
			{
				const gchar* _tmp2_;
				const gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				_tmp2_ = cmd;
				_tmp3_ = s;
				_tmp4_ = g_strconcat (KARIM_UTILS_STRING_UTIL_SPACE, _tmp3_, NULL);
				_tmp5_ = _tmp4_;
				_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
				_g_free0 (cmd);
				cmd = _tmp6_;
				_g_free0 (_tmp5_);
				_g_free0 (s);
			}
		}
	}
	{
		const gchar* _tmp7_;
		_tmp7_ = cmd;
		g_spawn_command_line_async (_tmp7_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch10_g_error;
		}
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = cmd;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		_tmp11_ = g_strdup_printf ("Unable to open item or folder with command %s. %s", _tmp8_, _tmp10_);
		_tmp12_ = _tmp11_;
		g_critical ("FileUtil.vala:47: %s", _tmp12_);
		_g_free0 (_tmp12_);
		_g_error_free0 (e);
	}
	__finally10:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (cmd);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (cmd);
}

/**
     * Create file and write.
     *
     * @since 1.0
     * @author Robert San - @robertsanseries
     *
     * Exemple:
     * > FileUtil.create_file("/etc", "ola.text", array.data);
     * 
     * @param {@code string} - dir
     * @param {@code string} - name_file
     * @param {@code GenericArray<string> > data} - words
     */
void
karim_utils_file_util_create_file (const gchar* dir,
                                   const gchar* name_file,
                                   gchar** words,
                                   gint words_length1)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (dir != NULL);
	g_return_if_fail (name_file != NULL);
	{
		GFile* directory = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
		GFile* file = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		gchar* text = NULL;
		gchar* _tmp9_;
		GFile* _tmp16_;
		_tmp0_ = g_file_new_for_path (dir);
		directory = _tmp0_;
		_tmp1_ = directory;
		if (!g_file_query_exists (_tmp1_, NULL)) {
			GFile* _tmp2_;
			_tmp2_ = directory;
			g_file_make_directory_with_parents (_tmp2_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (directory);
				goto __catch11_g_error;
			}
		}
		_tmp3_ = g_strconcat (dir, "/", NULL);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strconcat (_tmp4_, name_file, NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_file_new_for_path (_tmp6_);
		_tmp8_ = _tmp7_;
		_g_free0 (_tmp6_);
		_g_free0 (_tmp4_);
		file = _tmp8_;
		_tmp9_ = g_strdup (KARIM_UTILS_STRING_UTIL_EMPTY);
		text = _tmp9_;
		{
			gchar** word_collection = NULL;
			gint word_collection_length1 = 0;
			gint _word_collection_size_ = 0;
			gint word_it = 0;
			word_collection = words;
			word_collection_length1 = words_length1;
			for (word_it = 0; word_it < word_collection_length1; word_it = word_it + 1) {
				gchar* _tmp10_;
				gchar* word = NULL;
				_tmp10_ = g_strdup (word_collection[word_it]);
				word = _tmp10_;
				{
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					_tmp11_ = text;
					_tmp12_ = word;
					_tmp13_ = g_strconcat (KARIM_UTILS_STRING_UTIL_SPACE, _tmp12_, NULL);
					_tmp14_ = _tmp13_;
					_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
					_g_free0 (text);
					text = _tmp15_;
					_g_free0 (_tmp14_);
					_g_free0 (word);
				}
			}
		}
		_tmp16_ = file;
		if (!g_file_query_exists (_tmp16_, NULL)) {
			GFileOutputStream* file_stream = NULL;
			GFile* _tmp17_;
			GFileOutputStream* _tmp18_;
			GDataOutputStream* data_stream = NULL;
			GFileOutputStream* _tmp19_;
			GDataOutputStream* _tmp20_;
			GDataOutputStream* _tmp21_;
			const gchar* _tmp22_;
			_tmp17_ = file;
			_tmp18_ = g_file_create (_tmp17_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
			file_stream = _tmp18_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (text);
				_g_object_unref0 (file);
				_g_object_unref0 (directory);
				goto __catch11_g_error;
			}
			_tmp19_ = file_stream;
			_tmp20_ = g_data_output_stream_new ((GOutputStream*) _tmp19_);
			data_stream = _tmp20_;
			_tmp21_ = data_stream;
			_tmp22_ = text;
			g_data_output_stream_put_string (_tmp21_, _tmp22_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (data_stream);
				_g_object_unref0 (file_stream);
				_g_free0 (text);
				_g_object_unref0 (file);
				_g_object_unref0 (directory);
				goto __catch11_g_error;
			}
			_g_object_unref0 (data_stream);
			_g_object_unref0 (file_stream);
		}
		_g_free0 (text);
		_g_object_unref0 (file);
		_g_object_unref0 (directory);
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp23_ = e;
		_tmp24_ = _tmp23_->message;
		g_critical ("FileUtil.vala:88: %s", _tmp24_);
		_g_error_free0 (e);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

/**
     * Delete file.
     *
     * @since 1.0
     * @author Robert San - @robertsanseries
     *
     * Exemple:
     * > FileUtil.delete_file("/etc", "ola.text");
     * 
     * @param {@code string} - dir
     * @param {@code string} - name_file
     */
void
karim_utils_file_util_delete_file (const gchar* dir,
                                   const gchar* name_file)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (dir != NULL);
	g_return_if_fail (name_file != NULL);
	{
		GFile* file = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
		_tmp0_ = g_strconcat (dir, "/", NULL);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_strconcat (_tmp1_, name_file, NULL);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_file_new_for_path (_tmp3_);
		_tmp5_ = _tmp4_;
		_g_free0 (_tmp3_);
		_g_free0 (_tmp1_);
		file = _tmp5_;
		_tmp6_ = file;
		if (g_file_query_exists (_tmp6_, NULL)) {
			GFile* _tmp7_;
			_tmp7_ = file;
			g_file_delete (_tmp7_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (file);
				goto __catch12_g_error;
			}
		}
		_g_object_unref0 (file);
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_critical ("FileUtil.vala:113: %s", _tmp9_);
		_g_error_free0 (e);
	}
	__finally12:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

KarimUtilsFileUtil*
karim_utils_file_util_construct (GType object_type)
{
	KarimUtilsFileUtil* self = NULL;
	self = (KarimUtilsFileUtil*) g_type_create_instance (object_type);
	return self;
}

KarimUtilsFileUtil*
karim_utils_file_util_new (void)
{
	return karim_utils_file_util_construct (KARIM_UTILS_TYPE_FILE_UTIL);
}

static void
karim_utils_value_file_util_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
karim_utils_value_file_util_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		karim_utils_file_util_unref (value->data[0].v_pointer);
	}
}

static void
karim_utils_value_file_util_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = karim_utils_file_util_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
karim_utils_value_file_util_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
karim_utils_value_file_util_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		KarimUtilsFileUtil * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = karim_utils_file_util_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
karim_utils_value_file_util_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	KarimUtilsFileUtil ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = karim_utils_file_util_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
karim_utils_param_spec_file_util (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	KarimUtilsParamSpecFileUtil* spec;
	g_return_val_if_fail (g_type_is_a (object_type, KARIM_UTILS_TYPE_FILE_UTIL), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
karim_utils_value_get_file_util (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KARIM_UTILS_TYPE_FILE_UTIL), NULL);
	return value->data[0].v_pointer;
}

void
karim_utils_value_set_file_util (GValue* value,
                                 gpointer v_object)
{
	KarimUtilsFileUtil * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KARIM_UTILS_TYPE_FILE_UTIL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, KARIM_UTILS_TYPE_FILE_UTIL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		karim_utils_file_util_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		karim_utils_file_util_unref (old);
	}
}

void
karim_utils_value_take_file_util (GValue* value,
                                  gpointer v_object)
{
	KarimUtilsFileUtil * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KARIM_UTILS_TYPE_FILE_UTIL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, KARIM_UTILS_TYPE_FILE_UTIL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		karim_utils_file_util_unref (old);
	}
}

static void
karim_utils_file_util_class_init (KarimUtilsFileUtilClass * klass,
                                  gpointer klass_data)
{
	karim_utils_file_util_parent_class = g_type_class_peek_parent (klass);
	((KarimUtilsFileUtilClass *) klass)->finalize = karim_utils_file_util_finalize;
}

static void
karim_utils_file_util_instance_init (KarimUtilsFileUtil * self,
                                     gpointer klass)
{
	self->ref_count = 1;
}

static void
karim_utils_file_util_finalize (KarimUtilsFileUtil * obj)
{
	KarimUtilsFileUtil * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KARIM_UTILS_TYPE_FILE_UTIL, KarimUtilsFileUtil);
	g_signal_handlers_destroy (self);
}

GType
karim_utils_file_util_get_type (void)
{
	static volatile gsize karim_utils_file_util_type_id__volatile = 0;
	if (g_once_init_enter (&karim_utils_file_util_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { karim_utils_value_file_util_init, karim_utils_value_file_util_free_value, karim_utils_value_file_util_copy_value, karim_utils_value_file_util_peek_pointer, "p", karim_utils_value_file_util_collect_value, "p", karim_utils_value_file_util_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (KarimUtilsFileUtilClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) karim_utils_file_util_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KarimUtilsFileUtil), 0, (GInstanceInitFunc) karim_utils_file_util_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType karim_utils_file_util_type_id;
		karim_utils_file_util_type_id = g_type_register_fundamental (g_type_fundamental_next (), "KarimUtilsFileUtil", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&karim_utils_file_util_type_id__volatile, karim_utils_file_util_type_id);
	}
	return karim_utils_file_util_type_id__volatile;
}

gpointer
karim_utils_file_util_ref (gpointer instance)
{
	KarimUtilsFileUtil * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
karim_utils_file_util_unref (gpointer instance)
{
	KarimUtilsFileUtil * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		KARIM_UTILS_FILE_UTIL_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

