/* StringUtil.c generated by valac 0.46.6, the Vala compiler
 * generated from StringUtil.vala, do not modify */

/*
* Copyright (c) 2017 Robert San <robertsanseries@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>

#define KARIM_UTILS_TYPE_STRING_UTIL (karim_utils_string_util_get_type ())
#define KARIM_UTILS_STRING_UTIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KARIM_UTILS_TYPE_STRING_UTIL, KarimUtilsStringUtil))
#define KARIM_UTILS_STRING_UTIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KARIM_UTILS_TYPE_STRING_UTIL, KarimUtilsStringUtilClass))
#define KARIM_UTILS_IS_STRING_UTIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KARIM_UTILS_TYPE_STRING_UTIL))
#define KARIM_UTILS_IS_STRING_UTIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KARIM_UTILS_TYPE_STRING_UTIL))
#define KARIM_UTILS_STRING_UTIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KARIM_UTILS_TYPE_STRING_UTIL, KarimUtilsStringUtilClass))

typedef struct _KarimUtilsStringUtil KarimUtilsStringUtil;
typedef struct _KarimUtilsStringUtilClass KarimUtilsStringUtilClass;
typedef struct _KarimUtilsStringUtilPrivate KarimUtilsStringUtilPrivate;
typedef struct _KarimUtilsParamSpecStringUtil KarimUtilsParamSpecStringUtil;

struct _KarimUtilsStringUtil {
	GTypeInstance parent_instance;
	volatile int ref_count;
	KarimUtilsStringUtilPrivate * priv;
};

struct _KarimUtilsStringUtilClass {
	GTypeClass parent_class;
	void (*finalize) (KarimUtilsStringUtil *self);
};

struct _KarimUtilsParamSpecStringUtil {
	GParamSpec parent_instance;
};

static gpointer karim_utils_string_util_parent_class = NULL;

gpointer karim_utils_string_util_ref (gpointer instance);
void karim_utils_string_util_unref (gpointer instance);
GParamSpec* karim_utils_param_spec_string_util (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void karim_utils_value_set_string_util (GValue* value,
                                        gpointer v_object);
void karim_utils_value_take_string_util (GValue* value,
                                         gpointer v_object);
gpointer karim_utils_value_get_string_util (const GValue* value);
GType karim_utils_string_util_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KarimUtilsStringUtil, karim_utils_string_util_unref)
#define KARIM_UTILS_STRING_UTIL_SPACE " "
#define KARIM_UTILS_STRING_UTIL_EMPTY ""
#define KARIM_UTILS_STRING_UTIL_BREAK_LINE "\n"
gboolean karim_utils_string_util_is_empty (const gchar* value);
gboolean karim_utils_string_util_is_not_empty (const gchar* value);
gboolean karim_utils_string_util_is_blank (const gchar* value);
gboolean karim_utils_string_util_is_not_blank (const gchar* value);
KarimUtilsStringUtil* karim_utils_string_util_new (void);
KarimUtilsStringUtil* karim_utils_string_util_construct (GType object_type);
static void karim_utils_string_util_finalize (KarimUtilsStringUtil * obj);

/**
     * Checks if a string is empty ("") or null.
     *
     * @since 1.0
     * @author Robert San - @robertsanseries
     *
     * Exemple:
     * > StringUtil.is_empty(null)       = true
     * > StringUtil.is_empty("")         = true
     * > StringUtil.is_empty(" ")        = false
     * > StringUtil.is_empty("test")     = false
     * > StringUtil.is_empty("  test  ") = false
     * 
     * @param value - the string to check, not may be null
     * @return {@code bool} true - if the string is empty or null
     */
gboolean
karim_utils_string_util_is_empty (const gchar* value)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	if (value == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (value);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_ == 0;
	}
	result = _tmp0_;
	return result;
}

/**
     * Checks if a string is not empty ("") and not null.
     *
     * @since 1.0
     * @author Robert San - @robertsanseries
     * 
     * Exemple:
     * > StringUtil.is_not_empty(null)       = false
     * > StringUtil.is_not_empty("")         = false
     * > StringUtil.is_not_empty(" ")        = true
     * > StringUtil.is_not_empty("test")     = true
     * > StringUtil.is_not_empty("  test  ") = true
     *
     * @param value  the string to check, may be null
     * @return {@code bool} true -if the string is not empty and not null
     */
gboolean
karim_utils_string_util_is_not_empty (const gchar* value)
{
	gboolean result = FALSE;
	result = !karim_utils_string_util_is_empty (value);
	return result;
}

/**
     * Checks if a string is empty (""), null or with whitespace.
     *
     * @since 1.0
     * @author Robert San - @robertsanseries
     * 
     * Exemple:
     * > StringUtil.is_blank(null)      = true
     * > StringUtil.is_blank("")        = true
     * > StringUtil.is_blank(" ")       = true
     * > StringUtil.is_blank("test")     = false
     * > StringUtil.is_blank("  test  ") = false
     *
     * @param value  the string to check, may be null
     * @return {@code bool} - true if the string is null, empty or whitespace only
     */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

gboolean
karim_utils_string_util_is_blank (const gchar* value)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	if (value == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (value);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_ == 0;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gint _tmp6_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = strlen (value);
				_tmp6_ = _tmp5_;
				if (!(i < _tmp6_)) {
					break;
				}
				if (string_get (value, (glong) i) != ' ') {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}

/**
     * Checks if a string is not empty (""), not null or has no whitespace.
     *
     * @since 1.0
     * @author Robert San - @robertsanseries
     * 
     * Exemple:
     * > StringUtil.is_not_blank(null)      = false
     * > StringUtil.is_not_blank("")        = false
     * > StringUtil.is_not_blank(" ")       = false
     * > StringUtil.is_not_blank("test")     = true
     * > StringUtil.is_not_blank("  test  ") = true
     *
     * @param value  the string to check, may be null
     * @return {@code bool} - true if the string is not empty and not null and not whitespace only
     */
gboolean
karim_utils_string_util_is_not_blank (const gchar* value)
{
	gboolean result = FALSE;
	result = !karim_utils_string_util_is_blank (value);
	return result;
}

KarimUtilsStringUtil*
karim_utils_string_util_construct (GType object_type)
{
	KarimUtilsStringUtil* self = NULL;
	self = (KarimUtilsStringUtil*) g_type_create_instance (object_type);
	return self;
}

KarimUtilsStringUtil*
karim_utils_string_util_new (void)
{
	return karim_utils_string_util_construct (KARIM_UTILS_TYPE_STRING_UTIL);
}

static void
karim_utils_value_string_util_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
karim_utils_value_string_util_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		karim_utils_string_util_unref (value->data[0].v_pointer);
	}
}

static void
karim_utils_value_string_util_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = karim_utils_string_util_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
karim_utils_value_string_util_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
karim_utils_value_string_util_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		KarimUtilsStringUtil * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = karim_utils_string_util_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
karim_utils_value_string_util_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	KarimUtilsStringUtil ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = karim_utils_string_util_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
karim_utils_param_spec_string_util (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	KarimUtilsParamSpecStringUtil* spec;
	g_return_val_if_fail (g_type_is_a (object_type, KARIM_UTILS_TYPE_STRING_UTIL), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
karim_utils_value_get_string_util (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KARIM_UTILS_TYPE_STRING_UTIL), NULL);
	return value->data[0].v_pointer;
}

void
karim_utils_value_set_string_util (GValue* value,
                                   gpointer v_object)
{
	KarimUtilsStringUtil * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KARIM_UTILS_TYPE_STRING_UTIL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, KARIM_UTILS_TYPE_STRING_UTIL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		karim_utils_string_util_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		karim_utils_string_util_unref (old);
	}
}

void
karim_utils_value_take_string_util (GValue* value,
                                    gpointer v_object)
{
	KarimUtilsStringUtil * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KARIM_UTILS_TYPE_STRING_UTIL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, KARIM_UTILS_TYPE_STRING_UTIL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		karim_utils_string_util_unref (old);
	}
}

static void
karim_utils_string_util_class_init (KarimUtilsStringUtilClass * klass,
                                    gpointer klass_data)
{
	karim_utils_string_util_parent_class = g_type_class_peek_parent (klass);
	((KarimUtilsStringUtilClass *) klass)->finalize = karim_utils_string_util_finalize;
}

static void
karim_utils_string_util_instance_init (KarimUtilsStringUtil * self,
                                       gpointer klass)
{
	self->ref_count = 1;
}

static void
karim_utils_string_util_finalize (KarimUtilsStringUtil * obj)
{
	KarimUtilsStringUtil * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KARIM_UTILS_TYPE_STRING_UTIL, KarimUtilsStringUtil);
	g_signal_handlers_destroy (self);
}

GType
karim_utils_string_util_get_type (void)
{
	static volatile gsize karim_utils_string_util_type_id__volatile = 0;
	if (g_once_init_enter (&karim_utils_string_util_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { karim_utils_value_string_util_init, karim_utils_value_string_util_free_value, karim_utils_value_string_util_copy_value, karim_utils_value_string_util_peek_pointer, "p", karim_utils_value_string_util_collect_value, "p", karim_utils_value_string_util_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (KarimUtilsStringUtilClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) karim_utils_string_util_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KarimUtilsStringUtil), 0, (GInstanceInitFunc) karim_utils_string_util_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType karim_utils_string_util_type_id;
		karim_utils_string_util_type_id = g_type_register_fundamental (g_type_fundamental_next (), "KarimUtilsStringUtil", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&karim_utils_string_util_type_id__volatile, karim_utils_string_util_type_id);
	}
	return karim_utils_string_util_type_id__volatile;
}

gpointer
karim_utils_string_util_ref (gpointer instance)
{
	KarimUtilsStringUtil * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
karim_utils_string_util_unref (gpointer instance)
{
	KarimUtilsStringUtil * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		KARIM_UTILS_STRING_UTIL_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

