/* URLUtil.c generated by valac 0.46.6, the Vala compiler
 * generated from URLUtil.vala, do not modify */

/*
* Copyright (c) 2017 Robert San <robertsanseries@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>

#define KARIM_UTILS_TYPE_URL_UTIL (karim_utils_url_util_get_type ())
#define KARIM_UTILS_URL_UTIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KARIM_UTILS_TYPE_URL_UTIL, KarimUtilsURLUtil))
#define KARIM_UTILS_URL_UTIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KARIM_UTILS_TYPE_URL_UTIL, KarimUtilsURLUtilClass))
#define KARIM_UTILS_IS_URL_UTIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KARIM_UTILS_TYPE_URL_UTIL))
#define KARIM_UTILS_IS_URL_UTIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KARIM_UTILS_TYPE_URL_UTIL))
#define KARIM_UTILS_URL_UTIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KARIM_UTILS_TYPE_URL_UTIL, KarimUtilsURLUtilClass))

typedef struct _KarimUtilsURLUtil KarimUtilsURLUtil;
typedef struct _KarimUtilsURLUtilClass KarimUtilsURLUtilClass;
typedef struct _KarimUtilsURLUtilPrivate KarimUtilsURLUtilPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _KarimUtilsParamSpecURLUtil KarimUtilsParamSpecURLUtil;

struct _KarimUtilsURLUtil {
	GTypeInstance parent_instance;
	volatile int ref_count;
	KarimUtilsURLUtilPrivate * priv;
};

struct _KarimUtilsURLUtilClass {
	GTypeClass parent_class;
	void (*finalize) (KarimUtilsURLUtil *self);
};

struct _KarimUtilsParamSpecURLUtil {
	GParamSpec parent_instance;
};

static gpointer karim_utils_url_util_parent_class = NULL;

gpointer karim_utils_url_util_ref (gpointer instance);
void karim_utils_url_util_unref (gpointer instance);
GParamSpec* karim_utils_param_spec_url_util (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags);
void karim_utils_value_set_url_util (GValue* value,
                                     gpointer v_object);
void karim_utils_value_take_url_util (GValue* value,
                                      gpointer v_object);
gpointer karim_utils_value_get_url_util (const GValue* value);
GType karim_utils_url_util_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KarimUtilsURLUtil, karim_utils_url_util_unref)
gboolean karim_utils_url_util_check_url_with_regex (const gchar* url);
KarimUtilsURLUtil* karim_utils_url_util_new (void);
KarimUtilsURLUtil* karim_utils_url_util_construct (GType object_type);
static void karim_utils_url_util_finalize (KarimUtilsURLUtil * obj);

/**
     * Check if url is valid.
     *
     * @since 1.0
     * @author Robert San - @robertsanseries
     *
     * Exemple:
     * > URLUtil.check_url_with_regex("https://elementary.io");
     * 
     * @param {@code string} url 
     */
gboolean
karim_utils_url_util_check_url_with_regex (const gchar* url)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (url != NULL, FALSE);
	{
		GRegex* regex = NULL;
		GRegex* _tmp0_;
		GRegex* _tmp2_;
		_tmp0_ = g_regex_new ("(http|ftp|https)://[\\w-]+(\\.[\\w-]+)+([\\w.,@?^=%&amp;:/~+#-]*[\\w@?" \
"^=%&amp;/~+#-])?", 0, 0, &_inner_error0_);
		regex = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp1_ = FALSE;
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch13_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp1_;
		}
		_tmp2_ = regex;
		if (!g_regex_match (_tmp2_, url, 0, NULL)) {
			result = FALSE;
			_g_regex_unref0 (regex);
			return result;
		}
		_g_regex_unref0 (regex);
	}
	goto __finally13;
	__catch13_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_message ("URLUtil.vala:44: Erro: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally13:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp5_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	result = TRUE;
	return result;
}

KarimUtilsURLUtil*
karim_utils_url_util_construct (GType object_type)
{
	KarimUtilsURLUtil* self = NULL;
	self = (KarimUtilsURLUtil*) g_type_create_instance (object_type);
	return self;
}

KarimUtilsURLUtil*
karim_utils_url_util_new (void)
{
	return karim_utils_url_util_construct (KARIM_UTILS_TYPE_URL_UTIL);
}

static void
karim_utils_value_url_util_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
karim_utils_value_url_util_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		karim_utils_url_util_unref (value->data[0].v_pointer);
	}
}

static void
karim_utils_value_url_util_copy_value (const GValue* src_value,
                                       GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = karim_utils_url_util_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
karim_utils_value_url_util_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
karim_utils_value_url_util_collect_value (GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		KarimUtilsURLUtil * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = karim_utils_url_util_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
karim_utils_value_url_util_lcopy_value (const GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	KarimUtilsURLUtil ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = karim_utils_url_util_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
karim_utils_param_spec_url_util (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags)
{
	KarimUtilsParamSpecURLUtil* spec;
	g_return_val_if_fail (g_type_is_a (object_type, KARIM_UTILS_TYPE_URL_UTIL), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
karim_utils_value_get_url_util (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KARIM_UTILS_TYPE_URL_UTIL), NULL);
	return value->data[0].v_pointer;
}

void
karim_utils_value_set_url_util (GValue* value,
                                gpointer v_object)
{
	KarimUtilsURLUtil * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KARIM_UTILS_TYPE_URL_UTIL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, KARIM_UTILS_TYPE_URL_UTIL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		karim_utils_url_util_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		karim_utils_url_util_unref (old);
	}
}

void
karim_utils_value_take_url_util (GValue* value,
                                 gpointer v_object)
{
	KarimUtilsURLUtil * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KARIM_UTILS_TYPE_URL_UTIL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, KARIM_UTILS_TYPE_URL_UTIL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		karim_utils_url_util_unref (old);
	}
}

static void
karim_utils_url_util_class_init (KarimUtilsURLUtilClass * klass,
                                 gpointer klass_data)
{
	karim_utils_url_util_parent_class = g_type_class_peek_parent (klass);
	((KarimUtilsURLUtilClass *) klass)->finalize = karim_utils_url_util_finalize;
}

static void
karim_utils_url_util_instance_init (KarimUtilsURLUtil * self,
                                    gpointer klass)
{
	self->ref_count = 1;
}

static void
karim_utils_url_util_finalize (KarimUtilsURLUtil * obj)
{
	KarimUtilsURLUtil * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KARIM_UTILS_TYPE_URL_UTIL, KarimUtilsURLUtil);
	g_signal_handlers_destroy (self);
}

GType
karim_utils_url_util_get_type (void)
{
	static volatile gsize karim_utils_url_util_type_id__volatile = 0;
	if (g_once_init_enter (&karim_utils_url_util_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { karim_utils_value_url_util_init, karim_utils_value_url_util_free_value, karim_utils_value_url_util_copy_value, karim_utils_value_url_util_peek_pointer, "p", karim_utils_value_url_util_collect_value, "p", karim_utils_value_url_util_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (KarimUtilsURLUtilClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) karim_utils_url_util_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KarimUtilsURLUtil), 0, (GInstanceInitFunc) karim_utils_url_util_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType karim_utils_url_util_type_id;
		karim_utils_url_util_type_id = g_type_register_fundamental (g_type_fundamental_next (), "KarimUtilsURLUtil", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&karim_utils_url_util_type_id__volatile, karim_utils_url_util_type_id);
	}
	return karim_utils_url_util_type_id__volatile;
}

gpointer
karim_utils_url_util_ref (gpointer instance)
{
	KarimUtilsURLUtil * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
karim_utils_url_util_unref (gpointer instance)
{
	KarimUtilsURLUtil * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		KARIM_UTILS_URL_UTIL_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

